using System;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CSSamples {
    public partial class HighlightFeaturesWhileHovering : System.Web.UI.Page {
        protected void Page_Load(object sender, EventArgs e) {
            if (!Page.IsPostBack) {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-5677294.03045695, 44927335.4270966, 16586604.1281978, -1459732.2718805);
                Map1.MapUnit = GeographyUnit.Meter;
                Proj4Projection projection = new Proj4Projection(Proj4Projection.GetEpsgParametersString(4326), Proj4Projection.GetGoogleMapParametersString());

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                worldMapKitOverlay.Projection = WorldMapKitProjection.SphericalMercator;
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                //Map1.HighlightOverlay.Style = new FeatureOverlayStyle(); // When uncommented, this causes the HighlightOverlay to not work at all
                //Map1.HighlightOverlay.Style = new FeatureOverlayStyle(GeoColor.SimpleColors.Black, GeoColor.SimpleColors.Transparent, 3); // When uncommented, this causes the HighlightOverlay to not work at all
                //Map1.HighlightOverlay.Style = new FeatureOverlayStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Black, 3); // When uncommented, the HighlightOverlay works, but the feature is drawn in it even when not hovering

                Map1.HighlightOverlay.FeatureSource.Projection = projection;
                Map1.HighlightOverlay.HighlightStyle.OutlineColor = GeoColor.FromArgb(120, GeoColor.StandardColors.White);
                Map1.HighlightOverlay.HighlightStyle.FillColor = GeoColor.FromArgb(120, GeoColor.StandardColors.OrangeRed);
                Map1.HighlightOverlay.HighlightStyle.OutlineWidth = 3;

                BaseShape lineShape = new LineShape("LINESTRING(60 60, 70 70,75 60, 80 70, 85 60,95 80)");
                //Here you buffer the line shape, you could specify the distance or unit for it.
                MultipolygonShape bufferedShape = lineShape.Buffer(10, GeographyUnit.Meter, DistanceUnit.Feet);

                Map1.HighlightOverlay.Features.Add("Polygon", new Feature(BaseShape.CreateShapeFromWellKnownData("POLYGON((10 60,40 70,30 85, 10 60))")));
                Map1.HighlightOverlay.Features.Add("Multipoint", new Feature(BaseShape.CreateShapeFromWellKnownData("MULTIPOINT(12 20, 30 20,40 20, 12 30, 30 30, 40 30)")));
                //Map1.HighlightOverlay.Features.Add("Line", new Feature(BaseShape.CreateShapeFromWellKnownData("LINESTRING(60 60, 70 70,75 60, 80 70, 85 60,95 80)")));

                Map1.HighlightOverlay.Features.Add(new Feature(bufferedShape));
                
                Map1.HighlightOverlay.Features.Add("Rectangle", new Feature(new RectangleShape(65, 30, 90, 15)));
            }
        }
    }
}
